{% form_theme form 'bootstrap_4_layout.html.twig' %}

<div class="container">
    {{ form_start(form) }}

        <div class="row">
            <div class="col-md-6">{{ form_row(form.name) }}</div>
            <div class="col-md-3">{{ form_row(form.grade) }}</div>
            <div class="col-md-3">{{ form_row(form.person) }}</div>
        </div>

        <div class="row">
            <div class="col-md-9">{{ form_row(form.description) }}</div>
            <div class="col-md-3">{{ form_row(form.imageFile) }}</div>
        </div>

        <div class="row">
            <div class="col-md-12">{{ form_row(form.hashtags) }}</div>
        </div>

        <div class="row">
            <div class="col-md-12">
                {{ form_label(form.ingredients) }}
                {{ form_errors(form.ingredients) }}
                <ul class="mb-0 pl-0" id="ingredient-fields-list" data-prototype="{{ form_widget(form.ingredients.vars.prototype)| e }}" class="list-unstyled">
                    {% if form.ingredients | length > 0 %}
                        {% for ingredientField in form.ingredients %}
                            <li class="row justify-content-between align-items-center">
                                <div class="col-lg-9 col-md-7 col-sm-6">
                                    {{ form_errors(ingredientField) }}
                                    {{ form_widget(ingredientField) }}
                                </div>
                                <div class="col-lg-3 col-md-5 col-sm-6 mb-2">
                                    <button type="button" class="btn btn-danger supprimer">- Supprimer</button>
                                </div>
                            </li>
                        {% endfor %}
                    {% else %}
                        <li class="row justify-content-between align-items-center mb-2">
                            <div class="col-lg-9 col-md-7 col-sm-6">
                                {{ form_errors(form.ingredients) }}
                                {{ form_widget(form.ingredients) }}
                                <input type="text" id="recette_ingredients_0_name" name="recette[ingredients][0][name]" required="required" class="form-control">
                            </div>
                            <div class="col-lg-3 col-md-5 col-sm-6 mb-2">
                                <button type="button" class="btn btn-danger supprimer">- Supprimer</button>
                            </div>
                        </li>
                    {% endif %}
                </ul>
            </div>
            <div class="col-12 mb-4">
                <button type="button" class="btn btn-info text-white add_another_collection_widget" data-list-selector="ingredient-fields-list">
                    Ajouter un ingrédient
                </button>
            </div>
        </div>

        <div class="row">
            <div class="col-md-12">
                {{ form_label(form.etapes) }}
                {{ form_errors(form.etapes) }}
                <ul class="mb-0 pl-0" id="etape-fields-list" data-prototype="{{ form_widget(form.etapes.vars.prototype)| e }}" class="list-unstyled">
                    {% if form.etapes | length > 0 %}
                        {% for etapeField in form.etapes %}
                            <li class="row justify-content-between align-items-center">
                                <div class="col-lg-9 col-md-7 col-sm-6">
                                    {{ form_errors(etapeField) }}
                                    {{ form_widget(etapeField) }}
                                </div>
                                <div class="col-lg-3 col-md-5 col-sm-6 mb-2">
                                    <button type="button" class="btn btn-danger supprimer">- Supprimer</button>
                                </div>
                            </li>
                        {% endfor %}
                    {% else %}
                        <li class="row justify-content-between align-items-center mb-2">
                            <div class="col-lg-9 col-md-7 col-sm-6">
                                {{ form_errors(form.etapes) }}
                                {{ form_widget(form.etapes) }}
                                <textarea id="recette_etapes_0_description" name="recette[etapes][0][description]" required="required" class="form-control"></textarea>                            
                            </div>
                            <div class="col-lg-3 col-md-5 col-sm-6 mb-2">
                                <button type="button" class="btn btn-danger supprimer">- Supprimer</button>
                            </div>
                        </li>
                    {% endif %}
                </ul>
            </div>
            <div class="col-12 mb-2">
                <button type="button" class="btn btn-info text-white add_another_collection_widget" data-list-selector="etape-fields-list">
                    Ajouter une étape
                </button>
            </div>
        </div>
        <div class="row my-4">
            <div class="col-12">
                {{ form_row(form.online) }}
            </div>
        </div>

        {{ form_rest(form) }}
        
        <div class="text-center">
            <button class="btn btn-success btn-lg mb-5">{{ button|default('Enregistrer') }}</button>
        </div>
</div>

{% block javascript %}
    <script>
        var buttonNew    = document.querySelectorAll(".add_another_collection_widget"),
            buttonDelete = document.querySelectorAll('.supprimer');

            for(i = 0, count = buttonDelete.length; i < count; i++){

                buttonDelete[i].addEventListener("click", function(){
                    var ToDelete = this.parentNode.parentNode;

                    ToDelete.parentNode.removeChild(ToDelete);
                });

            }

            for(i = 0, count = buttonNew.length; i < count; i++){

                buttonNew[i].addEventListener("click", function(){
                    var list       = document.getElementById(this.getAttribute("data-list-selector")),
                        newWidget  = list.getAttribute("data-prototype"),
                        counter    = list.childNodes.length,
                        newElem    = document.createElement("li"), 
                        divInput   = document.createElement("div"),
                        divDelete  = document.createElement("div"),
                        buttonDelete = document.createElement("button");

                    newElem.className   = "row justify-content-between align-items-center";
                    divInput.className  = "col-lg-9 col-md-7 col-sm-6";
                    divDelete.className = "col-lg-3 col-md-5 col-sm-6 mb-2";

                    buttonDelete.className = "btn btn-danger supprimer";
                    buttonDelete.setAttribute("type", "button");
                    buttonDelete.innerHTML = "- Supprimer";

                    buttonDelete.addEventListener("click", function(){
                        var ToDelete = this.parentNode.parentNode;

                        ToDelete.parentNode.removeChild(ToDelete);
                    });

                    newWidget = newWidget.replaceAll(/__name__/g, counter);

                    divInput.innerHTML = newWidget;
                    divDelete.appendChild(buttonDelete);
                    newElem.appendChild(divInput);
                    newElem.appendChild(divDelete);
                    list.appendChild(newElem);
                });

            }            

    </script>
{% endblock %}